package de.tuberlin.cs.ni.neubauer.mpcd.assignments;


public class CommunityAssignments
{
	public CommunityAssignment[] assignments;
	double value;
	int numDimensions;
	int step;
	
	public CommunityAssignments(int numDimensions, int step)
	{
		this(numDimensions, step, -2);
	}	
	
	public CommunityAssignments(int numDimensions, int step, double value)
	{
		this.assignments = new CommunityAssignment[numDimensions];
		this.value = value;
		this.numDimensions = numDimensions;
		this.step = step;
	}
	
	public int getStep()
	{
		return this.step;
	}
	
	public CommunityAssignment get(int i)
	{
		return this.assignments[i];
	}
	
	public void put(int i, CommunityAssignment c)
	{
		this.assignments[i] = c;
	}
	
	public double getValue()
	{
		return this.value;
	}
	
	public void setValue(double value)
	{
		this.value = value;
	}

	/**
	 * performs a deep copy of the community assignments
	 * 
	 * @param communities
	 * @return
	 */
	public CommunityAssignments copyAssignments(double newValue, int step)
	{
		CommunityAssignments newAssignments = new CommunityAssignments(this.numDimensions, step, newValue);
		for (int i=0; i<this.numDimensions; i++)
			newAssignments.assignments[i] = this.assignments[i].deepCopy();
		return newAssignments;
	}
	
	public int size()
	{
		return this.numDimensions;
	}
}
