/**
 * 
 */
package de.tuberlin.cs.ni.neubauer.mpcd.gain;

import java.util.List;
import java.util.Map;

import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.JoinPair;
import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.Pair;

/**
 * keeps track of different GainTrackers and finds the best join at each point in time
 * @author nn
 *
 */
public interface GainTrackManager
{
	public JoinPair nextJoin();
	
	public void setPairs(int domain, Map<Pair,Double> pairValues);
	
	public void setPair(int domain, Pair pair, double value);
	
	public void updatePair(int domain, Pair pair, double delta);
	
	public Pair tieBreak(List<Pair> pairs);
	
	public void put(int domain, GainTracker gainTracker);
	
	public GainTracker get(int domain);
	
	public Boolean verboseOutput();
}
