/**
 * 
 */
package de.tuberlin.cs.ni.neubauer.mpcd.gain;

import java.util.Map;

import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.Pair;
import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.ProposedJoins;

/** 
 * stores the utility of pairwise joins between elements
 * can be queried for best join and associated score  
 * handles initialization, updates, and removal of joint elements
 *  
 * @author nn
 */
public interface GainTracker 
{
	/** remove all entries concerning @param element */
	public void removeElement(int element);
	
	/** update a single pair */
	public void setPair(Pair pair, double value);
	
	/** update a single pair's with a delta **/
	public void updatePair(Pair pair, double delta);
	
	/** update a number of pairs */
	public void setPairs(Map<Pair,Double> pairValues);
	
	public double getPairGain(Pair pair);
		
	/** get the best joins */
	public ProposedJoins getBestJoins();

}
