package de.tuberlin.cs.ni.neubauer.mpcd.gain;

import java.util.ArrayList;
import java.util.List;

import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.Pair;

public class PythonGainTrackManager extends DefaultGainTrackManager
{
	
	public PythonGainTrackManager(int numDimensions, Boolean verbose)
	{
		super(numDimensions, verbose);
	}


	@Override
	/**
	 * a slightly whimsical tie breaking routine preferring the pair with
	 * the smallest values. this is only important when trying to be compatible
	 * with the original Python code or if a rule is needed 
	 */
	public Pair tieBreak(List<Pair> pairs)
	{
		int smallest = pairs.get(0).smaller_element;
		ArrayList<Pair> smallPairs = new ArrayList<Pair>();
		for (Pair pair: pairs)
			if (pair.smaller_element==smallest)
			{
				smallPairs.add(pair);
			}
			else if (pair.smaller_element<smallest)
			{
				smallPairs = new ArrayList<Pair>(); 
				smallest = pair.smaller_element;
				smallPairs.add(pair);
			}
			
		if (smallPairs.size()==1)
			return smallPairs.get(0);
		
		smallest = smallPairs.get(0).bigger_element;
		Pair smallestPair = smallPairs.get(0);
		for (Pair pair: pairs)
			if (pair.bigger_element<smallest)
			{
				smallestPair = pair;
			}
		return smallestPair;
					
	}
}
