package de.tuberlin.cs.ni.neubauer.mpcd.io;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Set;

import de.tuberlin.cs.ni.neubauer.mpcd.assignments.CommunityAssignment;
import de.tuberlin.cs.ni.neubauer.mpcd.assignments.CommunityAssignments;

public class ConsoleExporter implements Exporter 
{

	@Override
	public void writeResults(CommunityAssignments assignments, DataContainer data) throws Exception 
	{
		for (int dimension=0; dimension<assignments.size(); dimension++)
		{
			CommunityAssignment assignment = assignments.assignments[dimension];
			Map<Integer, Integer> byNode = data.translateMap(assignment.byNode(), dimension);
			Set<Integer> nodes = byNode.keySet();
			List<Integer> sortedNodes = new ArrayList<Integer>();
			sortedNodes.addAll(nodes);
			Collections.sort(sortedNodes);
			for (int node: sortedNodes)
			{
				System.out.println(String.format("%d.%d: %d", 
						dimension, 
						node, 
						byNode.get(node)));
			}
		}		
	}

}
