package de.tuberlin.cs.ni.neubauer.mpcd.io;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import org.apache.commons.cli.CommandLine;


// C:\Users\nn\Desktop\workspace\Python\Tagging\output\synthetic\caveman\simple\10_10_1000_0.900\edges.txt
public class FileImporter implements Importer
{
	File file;
	
	public FileImporter(String filename)
	{
		this(new File(filename));
	}
	
	public FileImporter(File file)
	{
		this.file = file;
	}	
	
	@Override
	public DataContainer getEdges(CommandLine cmd) throws IOException
	{
		Scanner scanner = new Scanner(this.file);
		List<int[]> al = new ArrayList<int[]>();
		Boolean weighted = cmd.hasOption("w");
		List<Float> weights = new ArrayList<Float>();
		try
		{
			while (scanner.hasNextLine())
			{
				String[] line = scanner.nextLine().split(" ");
				if (weighted)
				{
					int[] values = new int[line.length-1];
					for(int i=0; i<line.length-1; i++)
					{
						values[i] = Integer.parseInt(line[i]);
					}
					al.add(values);
					weights.add(Float.parseFloat(line[line.length-1]));
				}
				else
				{
					int[] values = new int[line.length];
					for(int i=0; i<line.length; i++)
					{
						values[i] = Integer.parseInt(line[i]);
					}
					al.add(values);
				}
			}
		}
		finally
		{
			scanner.close();
		}
		return new DataContainer(al, cmd!=null?cmd.hasOption("w"):false, weights);
	}

}
