package de.tuberlin.cs.ni.neubauer.mpcd.listeners;

import de.tuberlin.cs.ni.neubauer.mpcd.Optimizer;
import de.tuberlin.cs.ni.neubauer.mpcd.io.FileExporter;
import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.JoinPair;

public class IntermediateOutputListener extends NoShutDownListener
{
	int interval;
	String baseFilename;
	
	public IntermediateOutputListener(String baseFilename, int interval)
	{
		this.baseFilename = baseFilename;
		this.interval = interval;
	}

	@Override
	public Boolean onStep(Optimizer optimizer, JoinPair joinPair)
			throws Exception 
	{
		int step = optimizer.step;
		if (this.interval==0)
		{
			if (step!=0)
				return false;
		}
		else
		{
			if (step%this.interval!=0) 
					return false;

		}
		String filename = String.format("%s.%d", this.baseFilename, step);		
		new FileExporter(filename, false).writeResults(optimizer.modularity.getCommunityAssignments(), 
												optimizer.modularity.getData());
		return false;
	}


}
