package de.tuberlin.cs.ni.neubauer.mpcd.listeners;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import de.tuberlin.cs.ni.neubauer.mpcd.Optimizer;
import de.tuberlin.cs.ni.neubauer.mpcd.io.DataContainer;
import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.JoinPair;

public class MergeOutputListener implements OptimizationStepListener 
{
	Writer output;
	static String newline = System.getProperty("line.separator");
	DataContainer data;
	
	public MergeOutputListener(String filename, DataContainer data) throws IOException
	{
		File file = new File(filename);
		this.output = new BufferedWriter(new FileWriter(file));
		this.data = data;
	}

	@Override
	public Boolean onStep(Optimizer optimizer, JoinPair joinPair) throws Exception 
	{		
		this.output.write(String.format("%d\t%d\t%d\t%f\t%d%s", 
				joinPair.dimension,
				this.data.getNewToOld(joinPair.dimension, joinPair.pair.bigger_element), 
				this.data.getNewToOld(joinPair.dimension, joinPair.pair.smaller_element),
				optimizer.modularity.getCurrentModularity(),
				optimizer.step,
				newline));
		
		return false;
	}
	
	public void shutDown()
	{
		try
		{
			this.output.close();
		}
		catch (Exception e)
		{
			System.err.println("error closing MergeOutputListener's writer: " + e.getMessage());
		}
	}

}
