package de.tuberlin.cs.ni.neubauer.mpcd.listeners;

import de.tuberlin.cs.ni.neubauer.mpcd.Optimizer;

import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.JoinPair;

/** 
 * an interface for classes to be registered for callbacks in OptimizationState's main loop
 * @author nn
 *
 */
public interface OptimizationStepListener
{
	/**
	 * 
	 * 
	 * @param state
	 * @param joinPair
	 * @param gain
	 * @return whether optimization should be aborted at this point
	 */
	public Boolean onStep(Optimizer optimizer, JoinPair joinPair) throws Exception;
	
	/**
	 * Listeners may open files etc, this is where they can be closed
	 */
	public void shutDown();
	
}
