package de.tuberlin.cs.ni.neubauer.mpcd.modularity;

import de.tuberlin.cs.ni.neubauer.mpcd.assignments.CommunityAssignments;
import de.tuberlin.cs.ni.neubauer.mpcd.gain.GainTrackManager;
import de.tuberlin.cs.ni.neubauer.mpcd.io.DataContainer;
import de.tuberlin.cs.ni.neubauer.mpcd.smalltypes.JoinPair;

public interface ModularityState
{
	public CommunityAssignments getCommunityAssignments();
	public GainTrackManager getGainTrackManager();
	public void join(JoinPair pair, GainTrackManager manager);
	public double getCurrentModularity();
	public double computeGain(JoinPair pair, Boolean computeMetadata);
	public int getNumDimensions();
	public DataContainer getData();
}
